//   This software is available only for non-commercial  amateur radio
//   or educational  applications.   ALL  other  uses  are  prohibited.
//   This  software may  be  modified  only  if the  resulting code  be
//   made available  publicly  and the  original  author given  credit.
//   Contact the author for information on commercial licenses.
//   (c) Copyright 1999,  John A. Hansen, W2FS.  All rights reserved.


#include <GPSE.H>
#include <PICEPAR.H>
#use rs232(baud=4800 ,rcv=PIN_A0,invert)

byte messbyte;
byte dest[7];
byte info[9];
byte indata[12];
byte qtime;
byte fl[3];
int i, stuff, dtime, beacon,btime,stime;
short flag,crcflag,slow;
int mbyte;
byte crclo,crchi;



void readvariable(){       //read the variable up to the next comma into indata[]
   i=indata[0]=indata[1]=indata[2]=indata[3]=0;
   do {
      indata[i] = getc();
      i++;
   }while ((indata[i-1] != 0x2c) & (i <12));
}


void getfloat(){              //gets the whole number portion of a floating point variable
readvariable();               //that has between 1 and 3 digits.  Places the digits in

   fl[0] = fl[1] = fl[2]=0;   //the three bytes of fl[]
   if (indata[3] == '.'){     //if there are 3 digits before the comma do this
      fl[0] = indata[0];
      fl[1] = indata[1];
      fl[2] = indata[2];
   }
   if (indata[2] == '.'){    //if there are 2 digits before the comma do this
      fl[1] = indata[0];
      fl[2] = indata[1];
   }
   if (indata[1] == '.') (fl[2] = indata[0] );  //if there is 1 digit before the comma do this.
   fl[0] = (fl[0] & 0x0F);   //strip the top nibble off all three bytes
   fl[1] = (fl[1] & 0x0f);
   fl[2] = (fl[2] & 0x0f);
}

void getposition(){
byte temp;

//following gets latitude, longitude, etc.

     while (indata[0] != 'G') (indata[0]=getc());
     while (indata[0] != 'P') (indata[0]=getc());
     while (indata[0] != 'R') (indata[0]=getc());
     while (indata[0] != 'M') (indata[0]=getc());
     while (indata[0] != 'C') (indata[0]=getc());
     while (indata[0] != ',') (indata[0]=getc());

     readvariable();
     readvariable();

     if (indata[0] == 'V') {
         (info[0] = 0x27);
         output_low(valid);
     }
     if (indata[0] != 'V') {
         (info[0] = 0x60);
         output_high(valid);
     }
     readvariable();
     temp = lookup(72);   //msg bits for config 0
     if (input(config)) (temp = lookup(73));  //msg bits for config 1

     dest[0] =  (0b01000000 & temp) | (0b00111111 & indata[0]); //insert the first message bit
  #ASM
     rlf  temp,f
  #ENDASM
     dest[1] =  (0b01000000 & temp) | (0b00111111 & indata[1]);  //and the second message bit
  #ASM
     rlf  temp,f
  #ENDASM
     dest[2] =  (0b01000000 & temp) | (0b00111111 & indata[2]); //and the third message bit
	  dest[3] =  0b00111111 & indata[3];
     dest[4] =  0b00111111 & indata[5];
     dest[5] =  0b00111111 & indata[6];
     readvariable();
     if (indata[0] == 'N') (BIT_SET(dest[3],6));
     readvariable();
     if (indata[0] == '1') (BIT_SET(dest[4],6));
     info[1] = ((indata[1] & 0b00001111)*10) + (indata[2] & 0b00001111);

     if (info[1] < 10){       //adjust 'D' if last two digits are less than 10
         if (indata[0] == '0') (info[1] = info[1] + 90);   //adjustment for D = 0-9
         if (indata[0] == '1') (info[1] = info[1] + 80);   //adjustment for D = 100-109
     }


     info[1] = info[1] + 28;
     if (info[2] <10) (info[2] = info[2] + 60);  // adjust 'M' if its less than 10
     info[2] = ((indata[3] & 0b00001111)*10) + (indata[4] & 0b00001111) + 28;
	  info[3] = ((indata[6] & 0b00001111)*10) + (indata[7] & 0b00001111) + 28;
     readvariable();
     if (indata[0] == 'W') (BIT_SET(dest[5],6));
     dest[6] = 0b11100000;  //path-n = 0;

     getfloat();

//following sets the speed data

     info[4] = (fl[0]*10) + fl[1];
     info[5] = (fl[2]*10);
     slow = FALSE;
     if ((info[0] == 0) && (info[1] == 0)) (slow = TRUE); // if (speed <10 then slow = true)
//set the course
     getfloat();
	  info[5] = (info[5] + fl[0] );
     info[6] = (fl[1]*10) + fl[2];


	  info[4] += 108;
	  info[5] += 32;
	  info[6] += 28;

   #asm
     BCF    03,0
     rlf  dest[0],f
     rlf  dest[1],F
     rlf  dest[2],F
     rlf  dest[3],f      // must multiply destination address by 2
     rlf  dest[4],f
     rlf  dest[5],f
    #endasm

}



void flipout(){			//flips the output state
	stuff = 0;
	if (!bit_test(port_b,5)) (output_high(pin_b5));
      else (output_low(pin_b5));
}


void crcbit(byte tbyte){

#asm
   BCF    03,0
   RRF    crchi,F    //rotates the entire 16 bits to the right
   RRF    crclo,F
#endasm
   if (((status & 0x01)^(tbyte)) ==0x01){
         crchi = crchi^0x84;
         crclo = crclo^0x08;
      }
 }

void sendbyte (byte inbyte){
   int k, bt;
   for (k=0;k<8;k++){
     bt = inbyte & 0x01;       //strip off the rightmost bit
     if ((!crcflag) && (!flag)) (crcbit(bt));   //do crc, but only if this is not a flag or crc byte
     if (!bt) (flipout());  // if this bit is a zero, flip the output state
        else {
	         stuff++;    //increment 1's count
            if ((!flag) && (stuff == 5)){   //stuff an extra 0, if 5 1's in a row
	           delay_us(860);
	           flipout();
	         }
        }
     #asm
        rrf   inbyte,F
     #endasm
     delay_us(860);

  }
}

void sendpacket(void){


   crclo=crchi=0xFF;
   stuff = 0;
   output_high(PTT);
   output_high(m0);
   output_low(m1);
   flag = TRUE;
   crcflag = FALSE;
   messbyte = lookup(56);
   if (input(manual)) (messbyte = lookup(57));
   for (i=0;i<messbyte;i++) (sendbyte(0x7E));	   //adjust length for txdelay
                                                         //each flag takes approx 6.7 ms
   flag = FALSE;
   for(i=0;i<7;i++) (sendbyte(dest[i]));        //send destination bytes
   i=0;
   if (input(config)) (i = 28);
   do {
      messbyte = lookup(i);
      i++;
      sendbyte(messbyte);

   }while (messbyte != 0x61);


   sendbyte(0x03);                          //send control byte
   sendbyte(0xF0);                          // send PID
   for(i=0;i<9;i++) (sendbyte(info[i]));    //send information part of packet
   beacon--;
   if (beacon == 0){      //send the message text now and then
        i= 74;            //location of beginning of message section
        if (input(config)) (i=i+51);
        messbyte = lookup(i);
        i++;
        While (messbyte != 0x00){
            sendbyte(messbyte);
            messbyte = lookup(i);
            i++;
        }
        beacon = btime;
   }


   crcflag = TRUE;
   crclo =crclo^0xff;
   crchi = crchi^0xff;
   sendbyte(crclo); //send the low byte of crc
   sendbyte(crchi); //send the high byte of crc

   FLAG = TRUE;
   sendbyte(0x7e);			  // Send a flag to end packet
   output_low(PTT);     //unkey PTT
   output_low(pin_b5);
   output_high(M1);    //put 614 back in receive mode
   output_low(M0);


}

main() {
   messbyte = lookup(0);
   set_tris_a(0x19);
   set_tris_b(0xd8);

   output_high(valid);
   delay_ms(1000);
   output_low(valid);
   output_low(valid);
   output_high(M0);  //zero power mode
   output_high(m1);
   output_low(PTT);   //  PTT OFF
   setup_counters(RTCC_INTERNAL,RTCC_DIV_2);
   beacon = 1;


While (TRUE){  		//Main loop ... do this until power is off or reset
      getposition();
      stime = 1;
      if (!input(config)) {
         btime = lookup(62);
         qtime = lookup(64);
         if (slow) (stime = lookup(66));
         info[7] = lookup(68);  //set the Icon Symbol
         info[8] = lookup(69);  //set the Icon Table
      }
      if (input(config)){
         btime = lookup(63);
         qtime = lookup(65);
         if (slow) (stime = lookup(67));
         info[7] = lookup(70);  //set the Icon Symbol
         info[8] = lookup(71);  //set the Icon Table
      }
        output_low(m0);       //set up MX614 to receive
        output_high(m1);
        output_low(pin_b5);
      if (input(manual)){
            while(input(inptt) && input(manual)){    //wait until ptt is keyed (grounded!) or manual is turned off
            }
            getposition();   //added to make sure position is still fresh.
            while(!input(inptt)){     //wait until ptt is unkeyed
            }
           if (input(manual)) (output_high(PTT));
      dtime = lookup(60);
      if (!input(config)) (dtime = lookup(58));
      }

         delay_ms(100);        //wait for MX614 to wake up
         if (!input(manual)){
               dtime = lookup(61);
               if (!input(config)) (dtime = lookup(59));
               while(input(vox)){   //wait until the channel is clear if auto
                  While(input(vox)){
                     for (i=0;i<qtime;i++) (delay_ms(1000)); //quiettime delay
                  }
               }


         }

         output_high(PTT);
         sendpacket();  //transmit the packet



         for (i=0;i<(dtime*stime);i++) (delay_ms(10000));	   // time delay


   }
}
